import React from 'react'
import Pane from './Pane'
import { css } from 'glamor'
import SyntaxHighlighter from 'react-syntax-highlighter'
import { docco } from 'react-syntax-highlighter/dist/styles'

const segmentStyle = {
  ...docco,
  hljs: {
    ...docco.hljs,
    background: 'transparent',
    padding: '0'
  }
}

const CodeBlock = ({ children, codeStyle, language, style, ...props }) =>
  <Pane {...css({ '& > pre': { margin: 0 } })} {...props}>
    <SyntaxHighlighter language={language} style={codeStyle}>{children}</SyntaxHighlighter>
  </Pane>

CodeBlock.propTypes = {
  ...Pane.propTypes,
  ...SyntaxHighlighter.propTypes
}

CodeBlock.defaultProps = {
  textAlign: 'left',
  tint: true,
  rounded: true,
  padding: 3,
  border: true,
  textStyle: 'mono',
  style: { overflowX: 'auto' },
  language: 'javascript',
  codeStyle: segmentStyle
}

export default CodeBlock
